package cl.tefix.ventas.GestionRutas.contactos.listado;

import cl.tefix.ventas.GestionRutas.*;
import cl.tefix.ventas.GestionRutas.excel.*;
import java.awt.*;
import java.awt.event.*;
import java.sql.*;
import javax.swing.*;
import javax.swing.table.*;
import java.util.*;

public class FrameListadoDeContactos extends JInternalFrame{

	public FrameListadoDeContactos(){
		iniciarComponentes();
                iniciarComboCargos();
                iniciarAcciones();
	}

	public void iniciarComponentes(){
		setTitle("Listado de Contactos");
		LabelNomEmp = new JLabel("Empresa");
		LabelNomDep = new JLabel("Dependencia");
		LabelNombre = new JLabel("Nombre");
		LabelCargo = new JLabel("Cargo");
		TextoNomEmp = new JTextField();
		TextoNomEmp.setPreferredSize(new Dimension(114,22));TextoNomEmp.setMinimumSize(new Dimension(114,22));
		TextoNomDep = new JTextField();
		TextoNomDep.setPreferredSize(new Dimension(114,22));TextoNomDep.setMinimumSize(new Dimension(114,22));
		TextoNombre = new JTextField();
		TextoNombre.setPreferredSize(new Dimension(114,22));TextoNombre.setMinimumSize(new Dimension(114,22));
		LabelYO = new JLabel("y/o");
		LabelYO2 = new JLabel("y/o");
		LabelYO3 = new JLabel("y/o");
		ComboCargo = new JComboBox();
		ComboCargo.setPreferredSize(new Dimension(130,24));ComboCargo.setMinimumSize(new Dimension(130,24));
		Tabla = new JTable();
		NombresColumnas = new String[] {"Empresa","Dependencia","Contacto","Cargo","fono","fax","Telfono","e-mail"};
		Tabla.setModel(new DefaultTableModel(new String[][] {},NombresColumnas));
		PanelScroll = new JScrollPane(Tabla);
		BotonExcel = new JButton(new javax.swing.ImageIcon(getClass().getResource("/recursos/iconos/excel.gif")));
		BarraBotones = new JToolBar();
		BarraBotones.add(BotonExcel);
		BotonAceptar = new JButton("Aceptar");
                BotonAceptar.setMinimumSize(new Dimension(90,25));BotonAceptar.setPreferredSize(new Dimension(90,25));
		getContentPane().setLayout(new GridBagLayout());

		c = new GridBagConstraints(0,0,1,1,0.0,0.0,18,0,new Insets(5,5,0,0),0,0);
		getContentPane().add(LabelNomEmp,c);
		c = new GridBagConstraints(0,-1,1,1,0.0,0.0,18,0,new Insets(0,5,0,0),0,0);
		getContentPane().add(TextoNomEmp,c);
		c = new GridBagConstraints(-1,1,1,1,0.0,0.0,18,0,new Insets(5,5,0,0),0,0);
		getContentPane().add(LabelYO,c);
		c = new GridBagConstraints(2,0,1,1,0.0,0.0,18,0,new Insets(5,5,0,0),0,0);
		getContentPane().add(LabelNomDep,c);
		c = new GridBagConstraints(2,-1,1,1,0.0,0.0,18,0,new Insets(0,5,0,0),0,0);
		getContentPane().add(TextoNomDep,c);
		c = new GridBagConstraints(-1,1,1,1,0.0,0.0,18,0,new Insets(5,5,0,0),0,0);
		getContentPane().add(LabelYO2,c);
		c = new GridBagConstraints(4,0,1,1,0.0,0.0,18,0,new Insets(5,5,0,0),0,0);
		getContentPane().add(LabelNombre,c);
		c = new GridBagConstraints(4,-1,1,1,0.0,0.0,18,0,new Insets(0,5,0,0),0,0);
		getContentPane().add(TextoNombre,c);
		c = new GridBagConstraints(-1,1,1,1,0.0,0.0,18,0,new Insets(5,5,0,0),0,0);
		getContentPane().add(LabelYO3,c);
		c = new GridBagConstraints(6,0,1,1,0.0,0.0,18,0,new Insets(5,5,0,0),0,0);
		getContentPane().add(LabelCargo,c);
		c = new GridBagConstraints(-1,1,1,1,1.0,0.0,18,0,new Insets(0,5,0,0),0,0);
		getContentPane().add(ComboCargo,c);
		c = new GridBagConstraints(0,2,1,1,0.0,0.0,18,0,new Insets(0,5,0,0),0,0);
		getContentPane().add(BotonAceptar,c);
		c = new GridBagConstraints(0,3,7,1,1.0,1.0,18,1,new Insets(5,5,0,5),0,0);
		getContentPane().add(PanelScroll,c);
		c = new GridBagConstraints(0,4,7,1,0.0,0.0,18,0,new Insets(0,5,5,5),0,0);
		getContentPane().add(BarraBotones,c);

                BotonAceptar.addActionListener(
                    new ActionListener(){
                      public void actionPerformed(ActionEvent e){
                        botonAceptarActionPerformed();
                      }
                    }
                );
                BotonExcel.addActionListener(
                    new ActionListener() {
                      public void actionPerformed(ActionEvent e){
                        BotonExcelActionPerformed();
                      }
                    }
                );
		setSize(700,500);
		setClosable(true);
		setIconifiable(true);
		setMaximizable(true);
		setResizable(true);
		setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
	}

        private void iniciarAcciones(){
            getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke("ENTER"),"Buscar");
            getActionMap().put("Buscar",
                new AbstractAction(){
                    public void actionPerformed(ActionEvent e){
                        botonAceptarActionPerformed();
                    }
                }
            );
        }

        private void BotonExcelActionPerformed() {
            Datos = new String [NumFilas][NumColumnas];
            for(int i=0;i<NumFilas;i++){
                for(int j=0;j<NumColumnas;j++){
                    Datos[i][j] = Tabla.getValueAt(i,j).toString();
                }
            }
            convertidor = new ConvertidorExcel(Datos,new String [] {"Empresa", "Dependencia", "Contacto", "Cargo","Telfono","Fax","Celular","e-mail"},NumFilas,NumColumnas);
            convertidor.generarArchivo();
        }

        private void botonAceptarActionPerformed(){
          NumFilas = 0;
          String Empresa,Dependencia,Nombre,Cargo;
          Empresa = "%" + TextoNomEmp.getText().toLowerCase() + "%";
          Dependencia = "%" + TextoNomDep.getText().toLowerCase() + "%";
          Nombre = "%" + TextoNombre.getText().toLowerCase() + "%";
          if(ComboCargo.getSelectedItem() == "Todos"){
            Cargo = "%%";
          }else{
            Cargo = ComboCargo.getSelectedItem().toString();
          }
          try{
            Statement stmt = GestionRutas.getConexion().createStatement(1004,1008);
            ResultSet rs = stmt.executeQuery("select * from lista_contactos where lower(nom_emp) like '" + Empresa + "' AND lower(nom_dep) like '" + Dependencia + "' AND lower(nombre) like '" + Nombre + "' AND cargo like '" + Cargo + "'");
            rs.last();
            NumFilas = rs.getRow();
            rs.beforeFirst();
            NumColumnas = rs.getMetaData().getColumnCount();
            Datos = new String [NumFilas][rs.getMetaData().getColumnCount()];
            rs.next();
            for(int i=0;i<NumFilas;i++){
              for(int j=0;j<NumColumnas;j++){
                Datos[i][j] = rs.getString(j+1);
              }
              rs.next();
            }
            rs.close();stmt.close();
            Tabla.setModel(new DefaultTableModel(Datos,NombresColumnas){
              public boolean isCellEditable(int x, int y){
                return false;
              }
            }
            );
          }catch(SQLException e){
            e.printStackTrace();
          }
        }
      //inicializa el ComboBox con los cargos
        private void iniciarComboCargos(){
            ComboCargo.addItem("Todos");
            try{
                Statement stmt = GestionRutas.getConexion().createStatement();
                ResultSet rs = stmt.executeQuery("select cargo from cargo_contacto");
                while(rs.next()){
                    ComboCargo.addItem(rs.getString(1));
                }
                rs.close();
                stmt.close();
            } catch(Exception e){
                e.printStackTrace();
            }
        }

//Declaraciones
private JLabel LabelNomEmp,LabelNomDep,LabelNombre,LabelCargo,LabelYO,LabelYO2,LabelYO3;
private JTextField TextoNomEmp,TextoNomDep,TextoNombre;
private JComboBox ComboCargo;
private JButton BotonAceptar,BotonExcel;
private JTable Tabla;
private JScrollPane PanelScroll;
private JToolBar BarraBotones;
private GridBagConstraints c;
private String [][] Datos;
private String [] NombresColumnas;
private int NumFilas, NumColumnas;
private ConvertidorExcel convertidor;
}
