package cl.tefix.ventas.GestionRutas.visitas.contactos;

import cl.tefix.ventas.GestionRutas.*;
import cl.tefix.ventas.GestionRutas.visitas.*;

import java.awt.event.*;
import java.sql.*;
import javax.swing.*;
import javax.swing.table.*;

public class FrameBuscarContactos extends javax.swing.JInternalFrame {

    public FrameBuscarContactos() {
        initComponents();
        iniciarCombo();
        iniciarAcciones();
    }

    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        TextoNombre = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        TablaContactos = new javax.swing.JTable();
        jToolBar1 = new javax.swing.JToolBar();
        BotonEnviar = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        ComboCargo = new javax.swing.JComboBox();
        BotonBuscar = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setClosable(true);
        setDefaultCloseOperation(javax.swing.WindowConstants.HIDE_ON_CLOSE);
        setIconifiable(true);
        setMaximizable(true);
        setResizable(true);
        setTitle("Buscar Contacto");
        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentHidden(java.awt.event.ComponentEvent evt) {
                formComponentHidden(evt);
            }
        });

        jLabel1.setText("Nombre");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        getContentPane().add(jLabel1, gridBagConstraints);

        TextoNombre.setMinimumSize(new java.awt.Dimension(114, 23));
        TextoNombre.setPreferredSize(new java.awt.Dimension(114, 23));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        getContentPane().add(TextoNombre, gridBagConstraints);

        TablaContactos.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Codigo", "Nombre", "Cargo", "Fono", "Fax", "Celular", "e-mail"
            }
        ));
        jScrollPane1.setViewportView(TablaContactos);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 5);
        getContentPane().add(jScrollPane1, gridBagConstraints);

        jToolBar1.setFloatable(false);
        BotonEnviar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/recursos/iconos/Back16.gif")));
        BotonEnviar.setToolTipText("Seleccionar el Contacto y regresar a la ventana de Visitas");
        BotonEnviar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BotonEnviarActionPerformed(evt);
            }
        });

        jToolBar1.add(BotonEnviar);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        getContentPane().add(jToolBar1, gridBagConstraints);

        jLabel2.setText("y/o");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        getContentPane().add(jLabel2, gridBagConstraints);

        jLabel3.setText("Cargo");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        getContentPane().add(jLabel3, gridBagConstraints);

        ComboCargo.setMinimumSize(new java.awt.Dimension(130, 23));
        ComboCargo.setPreferredSize(new java.awt.Dimension(130, 23));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        getContentPane().add(ComboCargo, gridBagConstraints);

        BotonBuscar.setText("Buscar");
        BotonBuscar.setMaximumSize(new java.awt.Dimension(100, 25));
        BotonBuscar.setMinimumSize(new java.awt.Dimension(100, 25));
        BotonBuscar.setPreferredSize(new java.awt.Dimension(100, 25));
        BotonBuscar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BotonBuscarActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        getContentPane().add(BotonBuscar, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-580)/2, (screenSize.height-350)/2, 580, 350);
    }//GEN-END:initComponents

    private void iniciarAcciones(){
        getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke("ENTER"), "Buscar");
        getActionMap().put("Buscar",
            new AbstractAction(){
                public void actionPerformed(ActionEvent e){
                    BotonBuscarActionPerformed(null);
                }
            }
        );
    }

    private void formComponentHidden(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentHidden
        TablaContactos.setModel(new DefaultTableModel(new String [][]{}, new String [] {"Codigo", "Nombre", "Cargo", "Fono", "Fax", "Celular", "e-mail"}));
        TextoNombre.setText("");
        ComboCargo.setSelectedIndex(0);
    }//GEN-LAST:event_formComponentHidden

    private void BotonEnviarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BotonEnviarActionPerformed
        if(TablaContactos.getSelectedRow() == -1){
            JOptionPane.showMessageDialog(this,"Error: debe seleccionar un Contacto","Error",0);
        }else{
            String codigo,nombre,cargo,fono,fax,celular,email;
            codigo = TablaContactos.getValueAt(TablaContactos.getSelectedRow(),0).toString();
            nombre = TablaContactos.getValueAt(TablaContactos.getSelectedRow(),1).toString();
            cargo = TablaContactos.getValueAt(TablaContactos.getSelectedRow(),2).toString();
            fono = TablaContactos.getValueAt(TablaContactos.getSelectedRow(),3).toString();
            fax = TablaContactos.getValueAt(TablaContactos.getSelectedRow(),4).toString();
            celular = TablaContactos.getValueAt(TablaContactos.getSelectedRow(),5).toString();
            email = TablaContactos.getValueAt(TablaContactos.getSelectedRow(),6).toString();
            FrameVisitas.getFrameVisitas().setContacto(codigo, nombre,cargo,fono,fax,celular, email);
            setVisible(false);
        }

    }//GEN-LAST:event_BotonEnviarActionPerformed

    private void BotonBuscarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BotonBuscarActionPerformed
        int NumFilas,NumColumnas;
        String tipo;
        String [][] datos;
        if(ComboCargo.getSelectedItem().toString().equals("Todos")){
            tipo = "%%";
        }else{
            tipo = ComboCargo.getSelectedItem().toString();
        }
        try{
            Statement stmt = GestionRutas.getConexion().createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,ResultSet.CONCUR_UPDATABLE);
            ResultSet rs = stmt.executeQuery("SELECT cod_cont,nombre,cargo_contacto.cargo,fono,fax,movil,email FROM contacto " +
            "WHERE contacto.cod_cont=contacto_dependencia.cod_cont " +
                "AND contacto_dependencia.cod_dep='" + CodigoDependencia + "' " +
                "AND contacto.cod_cargo=cargo_contacto.cod_cargo " +
                "AND cargo_contacto.cargo LIKE '" + tipo + "'"
            );
            rs.last();
            NumFilas = rs.getRow();
            NumColumnas = 7;
            rs.beforeFirst();
            datos = new String[NumFilas][NumColumnas];
            for(int i=0;i<NumFilas;i++){
                for(int j=0;j<NumColumnas;j++){
                    datos[i][j] = rs.getString(j+1);
                }
                rs.next();
            }
            rs.close();
            stmt.close();
            TableModel ModeloTabla = new DefaultTableModel(datos,new String [] {"Cdigo","Nombre","Cargo","Fono","Fax","Celular","e-mail"}){
                public boolean isCellEditable(){
                    return false;
                }
            };
            TablaContactos.setModel(ModeloTabla);
        }catch(SQLException e){
            e.printStackTrace();
        }

    }//GEN-LAST:event_BotonBuscarActionPerformed

    private void iniciarCombo(){
        ComboCargo.addItem("Todos");
        try{
            Statement stmt = GestionRutas.getConexion().createStatement();
            ResultSet rs = stmt.executeQuery("select cargo from cargo_contacto");
            while(rs.next()){
                ComboCargo.addItem(rs.getString(1));
            }
            rs.close();
            stmt.close();
        } catch(Exception e){
            e.printStackTrace();
        }
    }

    public void setCodigoDependencia(String codigo){
        CodigoDependencia = codigo;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton BotonBuscar;
    private javax.swing.JButton BotonEnviar;
    private javax.swing.JComboBox ComboCargo;
    private javax.swing.JTable TablaContactos;
    private javax.swing.JTextField TextoNombre;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JToolBar jToolBar1;
    // End of variables declaration//GEN-END:variables
    private String CodigoDependencia;
}
