package cl.tefix.ventas.GestionRutas;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.sql.*;
import com.l2fprod.gui.*;
import com.l2fprod.gui.plaf.skin.*;
import com.l2fprod.util.*;

public class GestionRutas extends javax.swing.JFrame {

    public GestionRutas() {
        initComponents();
        iniciarConexiones();
    }

    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        LabelCodigo = new javax.swing.JLabel();
        LabelClave = new javax.swing.JLabel();
        TextoCodigo = new javax.swing.JTextField();
        TextoPassword = new javax.swing.JPasswordField();
        ComboModalidad = new javax.swing.JComboBox();
        LabelModalidad = new javax.swing.JLabel();
        BotonIngresar = new javax.swing.JButton();
        LabelSistema = new javax.swing.JLabel();
        LabelTefix = new javax.swing.JLabel();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Gesti\u00f3n de Rutas");
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        LabelCodigo.setText("C\u00f3digo de Usuario");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        getContentPane().add(LabelCodigo, gridBagConstraints);

        LabelClave.setText("Contrase\u00f1a");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        getContentPane().add(LabelClave, gridBagConstraints);

        TextoCodigo.setMaximumSize(new java.awt.Dimension(2147483647, 22));
        TextoCodigo.setMinimumSize(new java.awt.Dimension(4, 22));
        TextoCodigo.setPreferredSize(new java.awt.Dimension(4, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        getContentPane().add(TextoCodigo, gridBagConstraints);

        TextoPassword.setMinimumSize(new java.awt.Dimension(4, 22));
        TextoPassword.setPreferredSize(new java.awt.Dimension(4, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        getContentPane().add(TextoPassword, gridBagConstraints);

        ComboModalidad.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Administrador" }));
        ComboModalidad.setMaximumSize(new java.awt.Dimension(32767, 24));
        ComboModalidad.setPreferredSize(new java.awt.Dimension(88, 24));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        getContentPane().add(ComboModalidad, gridBagConstraints);

        LabelModalidad.setText("Modalidad");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        getContentPane().add(LabelModalidad, gridBagConstraints);

        BotonIngresar.setText("Ingresar");
        BotonIngresar.setPreferredSize(new java.awt.Dimension(90, 23));
        BotonIngresar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BotonIngresarActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 0);
        getContentPane().add(BotonIngresar, gridBagConstraints);

        LabelSistema.setFont(new java.awt.Font("Microsoft Sans Serif", 0, 24));
        LabelSistema.setText("Sistema de Gesti\u00f3n de Rutas");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        getContentPane().add(LabelSistema, gridBagConstraints);

        LabelTefix.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 24));
        LabelTefix.setForeground(new java.awt.Color(255, 0, 0));
        LabelTefix.setText("TEFIX LTDA.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
        getContentPane().add(LabelTefix, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-360)/2, (screenSize.height-262)/2, 360, 262);
    }//GEN-END:initComponents

    private void iniciarConexiones(){
        try{
            Class.forName("org.postgresql.Driver");
        } catch(ClassNotFoundException e){
            e.printStackTrace();
        }
        try{
            conn = DriverManager.getConnection("jdbc:postgresql://127.0.0.1:5432/ventas","usuario", "password");
            ConnStatic = conn;
        }catch(SQLException e){
            e.printStackTrace();
        }
    }


    private void BotonIngresarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BotonIngresarActionPerformed
        int NumFilas = 0;
        String Clave=null,Modalidad=null;
        try{
            stmt = conn.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE,ResultSet.CONCUR_UPDATABLE);
            rs = stmt.executeQuery("select * from vendedor where cod_vend='" + TextoCodigo.getText() + "'");
            rs.last();
            NumFilas = rs.getRow();
            rs.beforeFirst();
            if(NumFilas > 0){
                rs.absolute(1);
                Clave = rs.getString(2);
                Modalidad = rs.getString(7);
            }
            rs.close();
            stmt.close();
        } catch(SQLException e){
            e.printStackTrace();
        }

        if(NumFilas == 0 ){
            JOptionPane.showMessageDialog(this,"Error: Ud no es un usuario del sistema","Error",JOptionPane.ERROR_MESSAGE);
        }else{
            if(!Clave.equals(TextoPassword.getText())){
                JOptionPane.showMessageDialog(this,"Error: su contrasea es incorrecta","Error",JOptionPane.ERROR_MESSAGE);
            }else{
                if(ComboModalidad.getSelectedItem().toString().equals("Administrador") && Modalidad.equals("Usuario")){
                    JOptionPane.showMessageDialog(this,"Error: Ud no puede iniciar sesin como Administrador","Error",JOptionPane.ERROR_MESSAGE);
                }else{
                    if(ComboModalidad.getSelectedItem().toString().equals("Administrador")){
                        new Admin().setVisible(true);
                    }else{
//                        Usuario = TextoCodigo.getText();
//                        rutasUsuario1 = new RutasUsuario();
//                        rutasUsuario1.setUsuario(Usuario);
//                        rutasUsuario1.setConexion(conexionSql1);
//                        rutasUsuario1.show();
                    }
                    setVisible(false);

                }
            }

        }
    }

    public static Connection getConexion(){
        return ConnStatic;
    }

    private void exitForm(java.awt.event.WindowEvent evt) {
        System.exit(0);
    }

    public static void main(String args[]) {
        try{
            Skin Skin1 = SkinLookAndFeel.loadThemePack(new String().getClass().getResource("/recursos/themepacks/aquathemepack.zip"));
            SkinLookAndFeel.setSkin(Skin1);
            UIManager.setLookAndFeel(new SkinLookAndFeel());
        }catch(Exception e){
          e.printStackTrace();
        }

        new GestionRutas().setVisible(true);

    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton BotonIngresar;
    private javax.swing.JComboBox ComboModalidad;
    private javax.swing.JLabel LabelClave;
    private javax.swing.JLabel LabelCodigo;
    private javax.swing.JLabel LabelModalidad;
    private javax.swing.JLabel LabelSistema;
    private javax.swing.JLabel LabelTefix;
    private javax.swing.JTextField TextoCodigo;
    private javax.swing.JPasswordField TextoPassword;
    private Connection conn;
    private static Connection ConnStatic;
    private Statement stmt;
    private ResultSet rs;
    private ResultSetMetaData rsmd;
//    RutasUsuario rutasUsuario1;
    private String Usuario;
}
