package cl.tefix.ventas.GestionRutas.dependencias;

import cl.tefix.ventas.GestionRutas.*;
import cl.tefix.ventas.GestionRutas.dependencias.*;
import cl.tefix.ventas.GestionRutas.contactos.*;
import cl.tefix.ventas.GestionRutas.excel.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.sql.*;
import java.awt.Dimension;

public class FrameDependencias extends javax.swing.JInternalFrame {

    public FrameDependencias() {
        initComponents();
        iniciarCombos();
        registrarAdminResizeListener();
        frameDependenciasEstatico = this;
    }

    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        ComboTipo = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        TablaDependencias = new javax.swing.JTable();
        ToolBarDependencias = new javax.swing.JToolBar();
        BotonNuevaDependencia = new javax.swing.JButton();
        ExcelDependencias = new javax.swing.JButton();
        BotonEliminarDependencia = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        ScrollPaneContactos = new javax.swing.JScrollPane();
        TablaContactos = new javax.swing.JTable();
        ToolBarContactos = new javax.swing.JToolBar();
        BotonNuevoContacto = new javax.swing.JButton();
        ExcelContactos = new javax.swing.JButton();
        BotonEliminarContacto = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setClosable(true);
        setDefaultCloseOperation(javax.swing.WindowConstants.HIDE_ON_CLOSE);
        setIconifiable(true);
        setMaximizable(true);
        setResizable(true);
        setTitle("Dependencias");
        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                formComponentResized(evt);
            }
        });

        jLabel1.setText("Tipo");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        getContentPane().add(jLabel1, gridBagConstraints);

        ComboTipo.setMinimumSize(new java.awt.Dimension(130, 24));
        ComboTipo.setPreferredSize(new java.awt.Dimension(130, 24));
        ComboTipo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ComboTipoActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        getContentPane().add(ComboTipo, gridBagConstraints);

        jLabel2.setText("Dependencia");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        getContentPane().add(jLabel2, gridBagConstraints);

        TablaDependencias.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Cdigo", "Nombre", "Direccin", "Ciudad", "Comuna", "Vendedor"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, true, true, true, true, true
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        TablaDependencias.getSelectionModel().addListSelectionListener(
            new javax.swing.event.ListSelectionListener(){
                public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                    llenarTablaContactos();
                }
            }
        );

        jScrollPane1.setViewportView(TablaDependencias);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        getContentPane().add(jScrollPane1, gridBagConstraints);

        ToolBarDependencias.setFloatable(false);
        BotonNuevaDependencia.setIcon(new javax.swing.ImageIcon(getClass().getResource("/recursos/iconos/New16.gif")));
        BotonNuevaDependencia.setToolTipText("Permite Crear una nueva Dependencia");
        BotonNuevaDependencia.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BotonNuevaDependenciaActionPerformed(evt);
            }
        });

        ToolBarDependencias.add(BotonNuevaDependencia);

        ExcelDependencias.setIcon(new javax.swing.ImageIcon(getClass().getResource("/recursos/iconos/excel.gif")));
        ExcelDependencias.setToolTipText("Permite Exportar los datos a MS-Excel");
        ExcelDependencias.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ExcelDependenciasActionPerformed(evt);
            }
        });

        ToolBarDependencias.add(ExcelDependencias);

        BotonEliminarDependencia.setIcon(new javax.swing.ImageIcon(getClass().getResource("/recursos/iconos/Delete16.gif")));
        BotonEliminarDependencia.setEnabled(false);
        BotonEliminarDependencia.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BotonEliminarDependenciaActionPerformed(evt);
            }
        });

        ToolBarDependencias.add(BotonEliminarDependencia);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        getContentPane().add(ToolBarDependencias, gridBagConstraints);

        jLabel3.setText("Contactos");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        getContentPane().add(jLabel3, gridBagConstraints);

        TablaContactos.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Cdigo", "Nombre", "Cargo", "Fono", "Fax", "Celular", "e-mail"
            }
        ));
        ScrollPaneContactos.setViewportView(TablaContactos);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        getContentPane().add(ScrollPaneContactos, gridBagConstraints);

        ToolBarContactos.setFloatable(false);
        BotonNuevoContacto.setIcon(new javax.swing.ImageIcon(getClass().getResource("/recursos/iconos/New16.gif")));
        BotonNuevoContacto.setToolTipText("Permite Crear un nuevo Contacto");
        BotonNuevoContacto.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BotonNuevoContactoActionPerformed(evt);
            }
        });

        ToolBarContactos.add(BotonNuevoContacto);

        ExcelContactos.setIcon(new javax.swing.ImageIcon(getClass().getResource("/recursos/iconos/excel.gif")));
        ExcelContactos.setToolTipText("Permite Exportar los datos a MS-Excel");
        ExcelContactos.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ExcelContactosActionPerformed(evt);
            }
        });

        ToolBarContactos.add(ExcelContactos);

        BotonEliminarContacto.setIcon(new javax.swing.ImageIcon(getClass().getResource("/recursos/iconos/Delete16.gif")));
        BotonEliminarContacto.setEnabled(false);
        ToolBarContactos.add(BotonEliminarContacto);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 0);
        getContentPane().add(ToolBarContactos, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-552)/2, (screenSize.height-390)/2, 552, 390);
    }//GEN-END:initComponents

    private void BotonNuevoContactoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BotonNuevoContactoActionPerformed
        try{
            iniciarFrameNuevoContacto();
            frameNuevoContacto.setCodDep(TablaDependencias.getValueAt(TablaDependencias.getSelectedRow(),0).toString());
            frameNuevoContacto.setVisible(true);
            frameNuevoContacto.setLocation((TamanoEscritorio.width-374)/2,(TamanoEscritorio.height-239)/2);
        }catch(java.lang.ArrayIndexOutOfBoundsException e){
            JOptionPane.showMessageDialog(this,"Error: debe seleccionar una Dependencia","Error",0);
        }
    }//GEN-LAST:event_BotonNuevoContactoActionPerformed

    private void iniciarFrameNuevoContacto(){
        if(frameNuevoContacto == null){
            frameNuevoContacto = new FrameNuevoContacto();
            Admin.getEscritorio().add(frameNuevoContacto);
        }
    }

    private void BotonEliminarDependenciaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BotonEliminarDependenciaActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_BotonEliminarDependenciaActionPerformed

    private void registrarAdminResizeListener(){
        TamanoEscritorio = Admin.getEscritorio().getSize();
        Admin.getFrameAdmin().addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                TamanoEscritorio = Admin.getEscritorio().getSize();
            }
        });

    }

    private void BotonNuevaDependenciaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BotonNuevaDependenciaActionPerformed
        if(ComboTipo.getSelectedItem().toString().equals("Elegir un Tipo")){
            JOptionPane.showMessageDialog(this,"Error: debe elegir un tipo de Dependencia","Error",0);
        }else{
            iniciarFrameNuevaDependencia();
            frameNuevaDependencia.setRut(Rut);
            frameNuevaDependencia.setTipoDependencia(ComboTipo.getSelectedItem().toString());
            frameNuevaDependencia.setLocation((TamanoEscritorio.width-344)/2,(TamanoEscritorio.height-244)/2);
            frameNuevaDependencia.setVisible(true);
        }

    }//GEN-LAST:event_BotonNuevaDependenciaActionPerformed

    private void iniciarFrameNuevaDependencia(){
        if(frameNuevaDependencia == null){
            frameNuevaDependencia = new FrameNuevaDependencia();
            Admin.getEscritorio().add(frameNuevaDependencia);
        }
    }


    private void ExcelContactosActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ExcelContactosActionPerformed
        DatosContactos = new String [NumFilasContactos][NumColumnasContactos];
        for(int i=0;i<NumFilasContactos;i++){
            for(int j=0;j<NumColumnasContactos;j++){
                DatosContactos[i][j] = TablaContactos.getValueAt(i,j).toString();
            }
        }
        convertidor = new ConvertidorExcel(DatosContactos,new String [] {"Cdigo", "Nombre", "Cargo", "Fono", "Fax" ,"Celular","e-mail"},NumFilasContactos,NumColumnasContactos);
        convertidor.generarArchivo();
    }//GEN-LAST:event_ExcelContactosActionPerformed

    private void ExcelDependenciasActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ExcelDependenciasActionPerformed
        DatosDependencias = new String [NumFilasDependencias][NumColumnasDependencias];
        for(int i=0;i<NumFilasDependencias;i++){
            for(int j=0;j<NumColumnasDependencias;j++){
                DatosDependencias[i][j] = TablaDependencias.getValueAt(i,j).toString();
            }
        }
        convertidor = new ConvertidorExcel(DatosDependencias,new String [] {"Cdigo", "Nombre", "Direccin", "Ciudad", "Comuna" ,"Vendedor"},NumFilasDependencias,NumColumnasDependencias);
        convertidor.generarArchivo();
    }//GEN-LAST:event_ExcelDependenciasActionPerformed

    private void formComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentResized
        this.fijarAnchosTablaDependencias();
    }//GEN-LAST:event_formComponentResized

    private void ComboTipoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ComboTipoActionPerformed
        if(!ComboTipo.getSelectedItem().toString().equals("Elegir un Tipo")){
            llenarTablaDependencias();
        } else{
            vaciarTablaDependencias();
            vaciarTablaContactos();
        }
    }//GEN-LAST:event_ComboTipoActionPerformed

    public void setRut(String rut){
        if(rut != Rut){
            Rut = rut;
            ComboTipo.setSelectedIndex(0);
        }
    }

    public void setSeleccion(int seleccion){
        Seleccion = seleccion;
    }


    public void setNombre(String nombre){
        NombreEmpresa = nombre;
        setTitle(NombreEmpresa);
    }

    private void iniciarCombos(){
        int NumFilas=0;

        // Obtenemos los Tipos de Dependencias
        try{
            stmtTipos = GestionRutas.getConexion().createStatement();
            rsTipos = stmtTipos.executeQuery("SELECT * FROM tipo_dep");
            rsTipos.last();NumFilas = rsTipos.getRow();rsTipos.beforeFirst();
            Tipos = new String[NumFilas][2];
            int i=0;
            while(rsTipos.next()){
                for(int j=0;j<2;j++){
                    Tipos[i][j] = rsTipos.getString(j+1);
                }
                i++;
            }
            stmtTipos.close();rsTipos.close();
        }catch(SQLException e){
            e.printStackTrace();
        }

        // Llenamos el combo con los tipos de dependencias
        ComboTipo.addItem("Elegir un Tipo");
        for(int i=0;i<NumFilas;i++){
            ComboTipo.addItem(Tipos[i][1]);
        }

        // Obtenemos los Tipos de Cargos de los Contactos
        try{
            stmtCargos = GestionRutas.getConexion().createStatement();
            rsCargos = stmtCargos.executeQuery("SELECT * FROM cargo_contacto");
            rsCargos.last();NumFilas = rsCargos.getRow();rsCargos.beforeFirst();
            Cargos = new String[NumFilas][2];
            int i=0;
            while(rsCargos.next()){
                for(int j=0;j<2;j++){
                    Cargos[i][j] = rsCargos.getString(j+1);
                }
                i++;
            }
            stmtCargos.close();rsCargos.close();
        }catch(SQLException e){
            e.printStackTrace();
        }

        // Llenamos el combo editor con los tipos de Cargos
        ComboEditorCargoContacto = new JComboBox();
        for(int i=0;i<NumFilas;i++){
            ComboEditorCargoContacto.addItem(Cargos[i][1]);
        }

        // Obtenemos los Vendedores
        try{
            stmtVendedor = GestionRutas.getConexion().createStatement();
            rsVendedor = stmtVendedor.executeQuery("SELECT cod_vend,nom_vend FROM vendedor");
            rsVendedor.last();NumFilas = rsVendedor.getRow();rsVendedor.beforeFirst();
            Vendedores = new String[NumFilas][2];
            int i=0;
            while(rsVendedor.next()){
                for(int j=0;j<2;j++){
                    Vendedores[i][j] = rsVendedor.getString(j+1);
                }
                i++;
            }
            stmtVendedor.close();rsVendedor.close();
        }catch(SQLException e){
            e.printStackTrace();
        }

        // Llenamos el combos editor con los tipos de Cargos
        ComboEditorVendedores = new JComboBox();
        for(int i=0;i<NumFilas;i++){
            ComboEditorVendedores.addItem(Vendedores[i][1]);
        }

    }

    public void llenarTablaDependencias(){
        String consulta,tipo;
        tipo = ComboTipo.getSelectedItem().toString();
        consulta = "SELECT cod_dep,nom_dep,direccion,ciudad,comuna,vendedor.nom_vend " +
            "FROM dependencia " +
            "WHERE Rut_emp='" + Rut + "' AND dependencia.tipo_dep=tipo_dep.cod_tipo AND tipo_dep.tipo_dep='" + tipo + "' AND dependencia.vendedor=vendedor.cod_vend order by nom_dep";
        NumColumnasDependencias = 6;
        DatosDependencias = null;
        conn = GestionRutas.getConexion();
        try{
            stmt = conn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,ResultSet.CONCUR_UPDATABLE);
            rs = stmt.executeQuery(consulta) ;
            rs.last();
            NumFilasDependencias = rs.getRow();
            rs.beforeFirst();
            DatosDependencias = new String[NumFilasDependencias][NumColumnasDependencias];
            int i=0;
            while(rs.next()){
                for(int j=0;j<NumColumnasDependencias;j++){
                    DatosDependencias[i][j] = rs.getString(j+1);
                }
                i++;
            }
            stmt.close();
            rs.close();
        }catch(SQLException e){
            e.printStackTrace();
        }

        TableModel Modelo = new DefaultTableModel(DatosDependencias, new String [] {"Cdigo", "Nombre", "Direccin", "Ciudad", "Comuna" ,"Vendedor"}){
            public boolean isCellEditable(int fila,int columna){
                if(columna == 0){
                    return false;
                }else{
                    return true;
                }
            }
        };
        TablaDependencias.setModel(Modelo);
        iniciarListenerTablaDependencias();
        fijarAnchosTablaDependencias();
        TablaDependencias.getColumnModel().getColumn(5).setCellEditor(new DefaultCellEditor(ComboEditorVendedores));
    }

    public void llenarTablaContactos(){
//        SeleccionActual = TablaDependencias.getSelectedRow();
        if(Seleccion != TablaDependencias.getSelectedRow()){
            Seleccion = TablaDependencias.getSelectedRow();
            if(TablaDependencias.getRowCount() != 0){
                try{
                	CodigoContacto=(TablaDependencias.getValueAt(Seleccion,0)).toString();
                }catch(Exception e){}
                    if(Seleccion>-1){
                        String consulta;
                        consulta = "select cod_cont,nombre,cargo_contacto.cargo,fono,fax,movil,email from contacto where contacto_dependencia.cod_dep=" + CodigoContacto + " and contacto.cod_cont=contacto_dependencia.cod_cont and contacto.cod_cargo=cargo_contacto.cod_cargo";
                        NumColumnasContactos = 7;DatosContactos = null;
                        conn = GestionRutas.getConexion();
                        try{
                            stmt = conn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,ResultSet.CONCUR_UPDATABLE);
                            rs = stmt.executeQuery(consulta) ;rs.last();NumFilasContactos = rs.getRow();rs.beforeFirst();
                            DatosContactos = new String[NumFilasContactos][NumColumnasContactos];
                            int i=0;
                            while(rs.next()){
                                for(int j=0;j<NumColumnasContactos;j++){
                                    DatosContactos[i][j] = rs.getString(j+1);
                                }
                                i++;
                            }
                            stmt.close();rs.close();
                        }catch(SQLException e){
                            e.printStackTrace();
                        }

                        TableModel Modelo = new DefaultTableModel(DatosContactos, new String [] {"Cdigo", "Nombre", "Cargo", "Fono", "Fax" ,"Celular","e-mail"}){
                            public boolean isCellEditable(int fila,int columna){
                                if(columna == 0){
                                    return false;
                                }else{
                                    return true;
                                }
                            }
                        };
                        TablaContactos.setModel(Modelo);
                        iniciarListenerTablaContactos();
                        fijarAnchosTablaContactos();
                        TablaContactos.getColumnModel().getColumn(2).setCellEditor(new DefaultCellEditor(ComboEditorCargoContacto));
                    }
            }
            else{
                vaciarTablaContactos();
            }
        }
    }

    private void iniciarListenerTablaDependencias(){
        TablaDependencias.getModel().addTableModelListener(
            new TableModelListener(){
                public void tableChanged(TableModelEvent e){
                    tablaDependenciasCambiada();
                }
            }
        );
    }

    private void iniciarListenerTablaContactos(){
        TablaContactos.getModel().addTableModelListener(
            new TableModelListener(){
                public void tableChanged(TableModelEvent e){
                    tablaContactosCambiada();
                }
            }
        );
    }

    private void tablaDependenciasCambiada(){
        int Fila, Columna;
        String Codigo,Dato;
        Fila = TablaDependencias.getSelectedRow();
        Columna = TablaDependencias.getSelectedColumn();
        Codigo = TablaDependencias.getValueAt(Fila, 0).toString();
        Dato = TablaDependencias.getValueAt(Fila, Columna).toString();
        try{
            stmt = conn.createStatement();
            if(Columna == 1){
                stmt.execute("UPDATE dependencia SET nom_dep ='" + Dato + "' WHERE cod_dep='" + Codigo + "'");
            }

            if(Columna == 2){
                stmt.execute("UPDATE dependencia SET direccion ='" + Dato + "' WHERE cod_dep='" + Codigo + "'");
            }

            if(Columna == 3){
                stmt.execute("UPDATE dependencia SET ciudad ='" + Dato + "' WHERE cod_dep='" + Codigo + "'");
            }

            if(Columna == 4){
                stmt.execute("UPDATE dependencia SET comuna ='" + Dato + "' WHERE cod_dep='" + Codigo + "'");
            }

            if(Columna == 5){
                stmt.execute("UPDATE dependencia SET vendedor =(SELECT cod_vend FROM vendedor WHERE nom_vend='" + Dato + "') WHERE cod_dep='" + Codigo + "'");
            }
            stmt.close();
        }catch(SQLException e){
            System.out.println("Error al modificar los datos");
            e.printStackTrace();
        }

    }

    private void tablaContactosCambiada(){
        int Fila, Columna;
        String Codigo,Dato;
        Fila = TablaContactos.getSelectedRow();
        Columna = TablaContactos.getSelectedColumn();
        Codigo = TablaContactos.getValueAt(Fila, 0).toString();
        Dato = TablaContactos.getValueAt(Fila, Columna).toString();
        try{
            stmt = conn.createStatement();
            if(Columna == 1){
                stmt.execute("UPDATE contacto SET nombre ='" + Dato + "' WHERE cod_cont='" + Codigo + "'");
            }

            if(Columna == 2){
                stmt.execute("UPDATE contacto SET cod_cargo =(SELECT cod_cargo FROM cargo_contacto WHERE cargo='" + Dato + "') WHERE cod_cont='" + Codigo + "'");
            }

            if(Columna == 3){
                stmt.execute("UPDATE contacto SET fono ='" + Dato + "' WHERE cod_cont='" + Codigo + "'");
            }

            if(Columna == 4){
                stmt.execute("UPDATE contacto SET fax ='" + Dato + "' WHERE cod_cont='" + Codigo + "'");
            }

            if(Columna == 5){
                stmt.execute("UPDATE contacto SET movil ='" + Dato + "' WHERE cod_cont='" + Codigo + "'");
            }

            if(Columna == 6){
                stmt.execute("UPDATE contacto SET email ='" + Dato + "' WHERE cod_cont='" + Codigo + "'");
            }
            stmt.close();
        }catch(SQLException e){
            System.out.println("Error al modificar los datos");
            e.printStackTrace();
        }

    }

    private void fijarAnchosTablaDependencias(){
        TablaDependencias.getColumnModel().getColumn(1).setPreferredWidth(TablaDependencias.getSize().width/5);
        TablaDependencias.getColumnModel().getColumn(2).setPreferredWidth(TablaDependencias.getSize().width/3);
        TablaDependencias.getColumnModel().getColumn(3).setPreferredWidth(TablaDependencias.getSize().width/8);
        TablaDependencias.getColumnModel().getColumn(4).setPreferredWidth(TablaDependencias.getSize().width/8);
        TablaDependencias.getColumnModel().getColumn(5).setPreferredWidth(TablaDependencias.getSize().width/5);
    }

    private void fijarAnchosTablaContactos(){
        TablaContactos.getColumnModel().getColumn(1).setPreferredWidth(TablaContactos.getSize().width/4);
        TablaContactos.getColumnModel().getColumn(2).setPreferredWidth(TablaContactos.getSize().width/5);
        TablaContactos.getColumnModel().getColumn(6).setPreferredWidth(TablaContactos.getSize().width/4);
    }


    private void vaciarTablaDependencias(){
        TablaDependencias.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Cdigo", "Nombre", "Direccin", "Ciudad", "Comuna", "Vendedor"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, true, true, true, true, true
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
    }

    private void vaciarTablaContactos(){
        TablaContactos.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Cdigo", "Nombre", "Cargo", "Fono", "Fax", "Celular","e-mail"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, true, true, true, true, true, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
    }

    public static FrameDependencias getFrameDependencias(){
        return frameDependenciasEstatico;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton BotonEliminarContacto;
    private javax.swing.JButton BotonEliminarDependencia;
    private javax.swing.JButton BotonNuevaDependencia;
    private javax.swing.JButton BotonNuevoContacto;
    private javax.swing.JComboBox ComboTipo;
    private javax.swing.JButton ExcelContactos;
    private javax.swing.JButton ExcelDependencias;
    private javax.swing.JScrollPane ScrollPaneContactos;
    private javax.swing.JTable TablaContactos;
    private javax.swing.JTable TablaDependencias;
    private javax.swing.JToolBar ToolBarContactos;
    private javax.swing.JToolBar ToolBarDependencias;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables

    private int Seleccion,NumFilasDependencias,NumColumnasDependencias,NumFilasContactos,NumColumnasContactos;
    private Connection conn;
    private Statement stmt,stmtTipos,stmtCargos,stmtVendedor;
    private ResultSet rs,rsTipos,rsCargos,rsVendedor;
    private ResultSetMetaData rsmd;
    private String [][] DatosDependencias,DatosContactos,Tipos,Cargos,Vendedores;
    private String Rut,NombreEmpresa,CodigoContacto;
    private JComboBox ComboEditorVendedores,ComboEditorCargoContacto;
    private ConvertidorExcel convertidor;
    private static FrameDependencias frameDependenciasEstatico;
    private FrameNuevaDependencia frameNuevaDependencia;
    private FrameNuevoContacto frameNuevoContacto;
    private Dimension TamanoEscritorio;
}
