package cl.tefix.ventas.GestionRutas.empresas;

import cl.tefix.ventas.GestionRutas.*;
import cl.tefix.ventas.GestionRutas.dependencias.*;
import cl.tefix.ventas.GestionRutas.excel.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.sql.*;

public class FrameEmpresas extends javax.swing.JInternalFrame {

    public FrameEmpresas() {
        initComponents();
        iniciarCombos();
        iniciarAcciones();
    }

    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        TextoRut = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        TextoNombre = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        ComboTipo = new javax.swing.JComboBox();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        BotonBuscar = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        TablaEmpresas = new javax.swing.JTable();
        ToolBarEmpresas = new javax.swing.JToolBar();
        BotonNuevaEmpresa = new javax.swing.JButton();
        BotonDetalles = new javax.swing.JButton();
        BotonExcel = new javax.swing.JButton();
        BotonBorrarEmpresa = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setClosable(true);
        setDefaultCloseOperation(javax.swing.WindowConstants.HIDE_ON_CLOSE);
        setIconifiable(true);
        setMaximizable(true);
        setResizable(true);
        setTitle("Empresas");
        jLabel1.setText("Rut");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        getContentPane().add(jLabel1, gridBagConstraints);

        TextoRut.setMinimumSize(new java.awt.Dimension(114, 22));
        TextoRut.setPreferredSize(new java.awt.Dimension(114, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        getContentPane().add(TextoRut, gridBagConstraints);

        jLabel2.setText("y/o");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 5, 0, 0);
        getContentPane().add(jLabel2, gridBagConstraints);

        TextoNombre.setMinimumSize(new java.awt.Dimension(114, 22));
        TextoNombre.setPreferredSize(new java.awt.Dimension(114, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        getContentPane().add(TextoNombre, gridBagConstraints);

        jLabel3.setText("Nombre");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        getContentPane().add(jLabel3, gridBagConstraints);

        ComboTipo.setMinimumSize(new java.awt.Dimension(130, 24));
        ComboTipo.setPreferredSize(new java.awt.Dimension(114, 24));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        getContentPane().add(ComboTipo, gridBagConstraints);

        jLabel4.setText("y/o");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 5, 0, 0);
        getContentPane().add(jLabel4, gridBagConstraints);

        jLabel5.setText("Tipo");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        getContentPane().add(jLabel5, gridBagConstraints);

        BotonBuscar.setText("Buscar");
        BotonBuscar.setMaximumSize(new java.awt.Dimension(100, 25));
        BotonBuscar.setMinimumSize(new java.awt.Dimension(100, 25));
        BotonBuscar.setPreferredSize(new java.awt.Dimension(100, 25));
        BotonBuscar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BotonBuscarActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        getContentPane().add(BotonBuscar, gridBagConstraints);

        TablaEmpresas.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Rut", "Nombre", "Tipo", "Prioridad"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, true, true, true
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        TablaEmpresas.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                TablaEmpresasComponentResized(evt);
            }
        });

        jScrollPane1.setViewportView(TablaEmpresas);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 5);
        getContentPane().add(jScrollPane1, gridBagConstraints);

        BotonNuevaEmpresa.setIcon(new javax.swing.ImageIcon(getClass().getResource("/recursos/iconos/New16.gif")));
        BotonNuevaEmpresa.setToolTipText("Permite Crear una nueva Empresa");
        BotonNuevaEmpresa.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BotonNuevaEmpresaActionPerformed(evt);
            }
        });

        ToolBarEmpresas.add(BotonNuevaEmpresa);

        BotonDetalles.setIcon(new javax.swing.ImageIcon(getClass().getResource("/recursos/iconos/Edit16.gif")));
        BotonDetalles.setToolTipText("Muestra los detalles de la empresa (Obras, Oficinas, etc...)");
        BotonDetalles.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BotonDetallesActionPerformed(evt);
            }
        });

        ToolBarEmpresas.add(BotonDetalles);

        BotonExcel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/recursos/iconos/excel.gif")));
        BotonExcel.setToolTipText("Permite Exportar los datos a MS-Excel");
        BotonExcel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BotonExcelActionPerformed(evt);
            }
        });

        ToolBarEmpresas.add(BotonExcel);

        BotonBorrarEmpresa.setIcon(new javax.swing.ImageIcon(getClass().getResource("/recursos/iconos/Delete16.gif")));
        BotonBorrarEmpresa.setToolTipText("Permite Eliminar una Empresa");
        BotonBorrarEmpresa.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BotonBorrarEmpresaActionPerformed(evt);
            }
        });

        ToolBarEmpresas.add(BotonBorrarEmpresa);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
        getContentPane().add(ToolBarEmpresas, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-540)/2, (screenSize.height-415)/2, 540, 415);
    }

    private void iniciarAcciones(){
        getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke("ENTER"),"Buscar");
        getActionMap().put("Buscar",
            new AbstractAction(){
                public void actionPerformed(ActionEvent e){
                    BotonBuscarActionPerformed(null);
                }
            }
        );
    }

    private void BotonBorrarEmpresaActionPerformed(java.awt.event.ActionEvent evt) {
        if(TablaEmpresas.getSelectedRow() == -1){
            JOptionPane.showMessageDialog(this,"Error: primero debe seleccionar una empresa","Error",0);
        }else{
            int eleccion;
            eleccion=JOptionPane.showConfirmDialog(this,"Est seguro que desea eliminar la Empresa seleccionada?","Advertencia",javax.swing.JOptionPane.YES_NO_CANCEL_OPTION);
            if(eleccion==0){
                Statement stmt;
                ResultSet rs;
                int Fila,NumDependencias;
                String Rut;
                Fila = TablaEmpresas.getSelectedRow();
                Rut = TablaEmpresas.getValueAt(Fila, 0).toString();
                try{
                    stmt = GestionRutas.getConexion().createStatement();
                    rs = stmt.executeQuery("select count(cod_dep) from dependencia where rut_emp ='" + Rut + "'");
                    rs.next();
                    NumDependencias = rs.getInt(1);
                    stmt.close();
                    if(NumDependencias > 0){
                        JOptionPane.showMessageDialog(this,"Error: La Empresa contiene "+ NumDependencias +" dependencias.\nPara eliminarla deber antes eliminar todas sus dependencias.","Error",0);
                    }else{
                        try{
                            stmt = GestionRutas.getConexion().createStatement();
                            stmt.execute("delete from empresa where rut_emp = '" + Rut + "'");
                            stmt.close();
                            JOptionPane.showMessageDialog(this,"La Empresa se ha eliminado correctamente","Informacin",1);
                            BotonBuscarActionPerformed(null);
                        }catch(SQLException e){
                            e.printStackTrace();
                        }
                    }
                }catch(SQLException e){
                    e.printStackTrace();
                }
            }
        }
    }

    private void BotonNuevaEmpresaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BotonNuevaEmpresaActionPerformed
        Admin.getFrameAdmin().mostrarFrameNuevaEmpresa();
    }

    private void BotonExcelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BotonExcelActionPerformed
        Datos = new String [NumFilas][NumColumnas];
        for(int i=0;i<NumFilas;i++){
            for(int j=0;j<NumColumnas;j++){
                Datos[i][j] = TablaEmpresas.getValueAt(i,j).toString();
            }
        }
        convertidor = new ConvertidorExcel(Datos,new String [] {"Rut", "Nombre", "Tipo", "Prioridad"},NumFilas,NumColumnas);
        convertidor.generarArchivo();
    }

    private void BotonDetallesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BotonDetallesActionPerformed
        if(TablaEmpresas.getSelectedRow() == -1){
            JOptionPane.showMessageDialog(this,"Error: primero debe seleccionar una empresa","Error",0);
        }else{
            iniciarFrameDependencias();
            int Fila;
            String Rut,Nombre;
            Fila = TablaEmpresas.getSelectedRow();
            Rut = TablaEmpresas.getValueAt(Fila, 0).toString();
            Nombre = TablaEmpresas.getValueAt(Fila, 1).toString();
            frameDependencias.setRut(Rut);
            frameDependencias.setNombre(Nombre);
            frameDependencias.setVisible(true);
        }
    }

    private void iniciarFrameDependencias(){
        if(frameDependencias == null){
            frameDependencias = new FrameDependencias();
            frameDependencias.setLocation(100,10);
            Admin.getEscritorio().add(frameDependencias);
        }
    }

    private void iniciarListener(){
        TablaEmpresas.getModel().addTableModelListener(
            new TableModelListener(){
                public void tableChanged(TableModelEvent e){
                    tablaCambiada();
                }
            }
        );
    }

    private void tablaCambiada(){
        int Fila, Columna;
        String Rut,Dato,Tipo;
        Fila = TablaEmpresas.getSelectedRow();
        Columna = TablaEmpresas.getSelectedColumn();
        Rut = TablaEmpresas.getValueAt(Fila, 0).toString();
        Dato = TablaEmpresas.getValueAt(Fila, Columna).toString();
        try{
            stmt = conn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,ResultSet.CONCUR_UPDATABLE);
            if(Columna == 1){
                stmt.execute("UPDATE empresa SET nom_emp ='" + Dato + "' WHERE rut_emp='" + Rut + "'");
            }

            if(Columna == 2){
                stmt.execute("UPDATE empresa SET tipo_emp =(SELECT cod_tipo FROM tipo_emp WHERE tipo_emp='" + Dato + "') WHERE rut_emp='" + Rut + "'");
            }

            if(Columna == 3){
                stmt.execute("UPDATE empresa SET prioridad ='" + Dato + "' WHERE rut_emp='" + Rut + "'");
            }
            stmt.close();
        }catch(SQLException e){
            System.out.println("Error al modificar los datos");
            e.printStackTrace();
        }

    }

    private void TablaEmpresasComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_TablaEmpresasComponentResized
        fijarAnchos();
    }

    private void BotonBuscarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BotonBuscarActionPerformed
        String tipo;
        if(ComboTipo.getSelectedItem().toString().equals("Todos")){
            tipo = "%%";
        }
        else{
            tipo = ComboTipo.getSelectedItem().toString();
        }

        NumColumnas = 4;
        Datos = null;
        conn = GestionRutas.getConexion();
        try{
            stmt = conn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,ResultSet.CONCUR_UPDATABLE);
            rs = stmt.executeQuery("SELECT rut_emp,nom_emp,tipo_emp.tipo_emp,prioridad FROM empresa WHERE rut_emp like '%" + TextoRut.getText() + "%' AND lower(nom_emp) LIKE '%" + TextoNombre.getText().toLowerCase() + "%'  AND tipo_emp.tipo_emp LIKE '" + tipo + "' AND empresa.tipo_emp = tipo_emp.cod_tipo") ;
            rs.last();
            NumFilas = rs.getRow();
            rs.beforeFirst();
            Datos = new String[NumFilas][NumColumnas];
            int i=0;
            while(rs.next()){
                for(int j=0;j<NumColumnas;j++){
                    Datos[i][j] = rs.getString(j+1);
                }
                i++;
            }
            stmt.close();
            rs.close();
        }catch(SQLException e){
            e.printStackTrace();
        }

        TableModel Modelo = new DefaultTableModel(Datos, new String [] {"Rut", "Nombre", "Tipo", "Prioridad"}){
            public boolean isCellEditable(int fila,int columna){
                if(columna == 0){
                    return false;
                }else{
                    return true;
                }
            }
        };
        TablaEmpresas.setModel(Modelo);
        iniciarListener();
        fijarAnchos();
        TablaEmpresas.getColumnModel().getColumn(2).setCellEditor(new DefaultCellEditor(ComboEditor));
    }

    private void fijarAnchos(){
        TablaEmpresas.getColumnModel().getColumn(1).setPreferredWidth(TablaEmpresas.getSize().width/2);
    }

    private void iniciarCombos(){
        int NumFilas=0;
        try{
            stmtTipos = GestionRutas.getConexion().createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,ResultSet.CONCUR_UPDATABLE);
            rsTipos = stmtTipos.executeQuery("SELECT * FROM tipo_emp");
            rsTipos.last();
            NumFilas = rsTipos.getRow();
            rsTipos.beforeFirst();
            Tipos = new String[NumFilas][2];
            int i=0;
            while(rsTipos.next()){
                for(int j=0;j<2;j++){
                    Tipos[i][j] = rsTipos.getString(j+1);
                }
                i++;
            }
            stmtTipos.close();
            rsTipos.close();
        }catch(SQLException e){
            e.printStackTrace();
        }
        ComboEditor = new JComboBox();
        ComboTipo.addItem("Todos");
        for(int i=0;i<NumFilas;i++){
            ComboEditor.addItem(Tipos[i][1]);
            ComboTipo.addItem(Tipos[i][1]);
        }
    }


    // declaraciones
    private javax.swing.JButton BotonBorrarEmpresa;
    private javax.swing.JButton BotonBuscar;
    private javax.swing.JButton BotonDetalles;
    private javax.swing.JButton BotonExcel;
    private javax.swing.JButton BotonNuevaEmpresa;
    private javax.swing.JComboBox ComboTipo;
    private javax.swing.JTable TablaEmpresas;
    private javax.swing.JTextField TextoNombre;
    private javax.swing.JTextField TextoRut;
    private javax.swing.JToolBar ToolBarEmpresas;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JScrollPane jScrollPane1;
    private Connection conn;
    private Statement stmt,stmtTipos;
    private ResultSet rs,rsTipos;
    private ResultSetMetaData rsmd;
    private String [][] Datos,Tipos;
    private JComboBox ComboEditor;
    private FrameDependencias frameDependencias;
    private ConvertidorExcel convertidor;
    private int NumFilas,NumColumnas;
}
