package cl.tefix.ventas.GestionRutas.empresas.tipos;

import cl.tefix.ventas.GestionRutas.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.sql.*;
import java.util.*;

public class FrameNuevoTipoEmpresa extends javax.swing.JInternalFrame {

    public FrameNuevoTipoEmpresa() {
        initComponents();
        llenarLista();
    }

    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        LabelNuevo = new javax.swing.JLabel();
        LabelEjemplo = new javax.swing.JLabel();
        LabelSeleccion = new javax.swing.JLabel();
        TextoNuevo = new javax.swing.JTextField();
        TextoSeleccion = new javax.swing.JTextField();
        ScrollPane = new javax.swing.JScrollPane();
        Lista = new javax.swing.JList();
        BotonCrear = new javax.swing.JButton();
        BotonModificar = new javax.swing.JButton();
        BotonEliminar = new javax.swing.JButton();
        LabelTiposExistentes = new javax.swing.JLabel();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setClosable(true);
        setDefaultCloseOperation(javax.swing.WindowConstants.HIDE_ON_CLOSE);
        setIconifiable(true);
        setTitle("Nuevo Tipo de Empresa");
        LabelNuevo.setText("Nuevo");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        getContentPane().add(LabelNuevo, gridBagConstraints);

        LabelEjemplo.setText("(Ej: Constructora)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        getContentPane().add(LabelEjemplo, gridBagConstraints);

        LabelSeleccion.setText("Selecci\u00f3n");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        getContentPane().add(LabelSeleccion, gridBagConstraints);

        TextoNuevo.setMinimumSize(new java.awt.Dimension(114, 22));
        TextoNuevo.setPreferredSize(new java.awt.Dimension(114, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        getContentPane().add(TextoNuevo, gridBagConstraints);

        TextoSeleccion.setMinimumSize(new java.awt.Dimension(114, 22));
        TextoSeleccion.setPreferredSize(new java.awt.Dimension(114, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        getContentPane().add(TextoSeleccion, gridBagConstraints);

        Lista.addListSelectionListener(
            new ListSelectionListener(){
                public void valueChanged(ListSelectionEvent e){
                    if(e.getValueIsAdjusting()==false){
                        if(Lista.getSelectedIndex()==-1){
                            BotonModificar.setEnabled(false);
                            BotonEliminar.setEnabled(false);
                        }else{
                            BotonModificar.setEnabled(true);
                            BotonEliminar.setEnabled(true);
                            TextoSeleccion.setText(Lista.getSelectedValue().toString());
                        }
                    }
                }
            }
        );

        ScrollPane.setViewportView(Lista);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        getContentPane().add(ScrollPane, gridBagConstraints);

        BotonCrear.setText("Crear");
        BotonCrear.setMaximumSize(new java.awt.Dimension(100, 25));
        BotonCrear.setMinimumSize(new java.awt.Dimension(100, 25));
        BotonCrear.setPreferredSize(new java.awt.Dimension(100, 25));
        BotonCrear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BotonCrearActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 5);
        getContentPane().add(BotonCrear, gridBagConstraints);

        BotonModificar.setText("Modificar");
        BotonModificar.setMinimumSize(new java.awt.Dimension(100, 25));
        BotonModificar.setPreferredSize(new java.awt.Dimension(100, 25));
        BotonModificar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BotonModificarActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 0);
        getContentPane().add(BotonModificar, gridBagConstraints);

        BotonEliminar.setText("Eliminar");
        BotonEliminar.setMinimumSize(new java.awt.Dimension(100, 25));
        BotonEliminar.setPreferredSize(new java.awt.Dimension(100, 25));
        BotonEliminar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BotonEliminarActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 0);
        getContentPane().add(BotonEliminar, gridBagConstraints);

        LabelTiposExistentes.setText("Tipos Existentes");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        getContentPane().add(LabelTiposExistentes, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-330)/2, (screenSize.height-358)/2, 330, 358);
    }//GEN-END:initComponents

    private void BotonModificarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BotonModificarActionPerformed
        int eleccion;
        eleccion=JOptionPane.showConfirmDialog(this,"Est seguro que desea modificar el tipo de Empresa seleccionado?.\nAsegrese de que no existan empresas de dicho tipo.","Advertencia",javax.swing.JOptionPane.YES_NO_CANCEL_OPTION);
        if(eleccion == 0){
            try{
/*                Statement stmt = GestionRutas.getConexion().createStatement();
                stmt.execute("begin");
                stmt.execute("update tipo_emp set tipo_emp='" + TextoSeleccion.getText() + "' where tipo_emp='" + Lista.getSelectedValue() + "'");
                stmt.execute("update empresa set tipo_emp=(select cod_tipo from tipo_emp where tipo_emp='" + TextoSeleccion.getText() + "') where cod_tipo=(select cod_tipo from tipo_emp where tipo_emp='" + Lista.getSelectedValue() + "')");
                stmt.execute("commit");
                stmt.close();
 */


                JOptionPane.showMessageDialog(this,"Se ha modificado correctamente el tipo de Empresa y todas las Empresas asociadas","Informacin",1);
            }catch(Exception e){
                JOptionPane.showMessageDialog(this,e.getMessage());
            }
            llenarLista();
        }
    }//GEN-LAST:event_BotonModificarActionPerformed

    private void BotonEliminarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BotonEliminarActionPerformed
        int eleccion,NumeroDeCoincidencias;
        eleccion=JOptionPane.showConfirmDialog(this,"Est seguro que desea borrar el tipo de Empresa seleccionado?","Advertencia",javax.swing.JOptionPane.YES_NO_CANCEL_OPTION);
        if(eleccion==0){
            try{
                Statement stmt;
                stmt = GestionRutas.getConexion().createStatement();
                ResultSet rs = stmt.executeQuery("select count(rut_emp) from empresa where cod_tipo=(SELECT cod_tipo FROM tipo_emp WHERE tipo_emp='" + Lista.getSelectedValue() + "')");
                rs.next();
                NumeroDeCoincidencias = rs.getInt(1);
                rs.close();
                stmt.close();
                if(NumeroDeCoincidencias > 0){
                    JOptionPane.showMessageDialog(this,"Error: existen " + NumeroDeCoincidencias + " Empresas de este tipo.\nPara eliminarlo, antes debe cambiar el tipo a dichas Empresas o eliminarlas","Error",0);
                }else{
                        stmt = GestionRutas.getConexion().createStatement();
                        stmt.execute("delete from tipo_emp where tipo_emp ='" + Lista.getSelectedValue() + "'");
                        stmt.close();
                        JOptionPane.showMessageDialog(this,"El tipo de Empresa se ha eliminado correctamente","Informacin",JOptionPane.INFORMATION_MESSAGE);
                        llenarLista();
                }
            }catch(SQLException e){
              JOptionPane.showMessageDialog(this,"Error: No se puede eliminar el tipo\n" + e.getMessage(),"Error",0);
              //e.printStackTrace();
            }
        }
    }

    private void BotonCrearActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BotonCrearActionPerformed
        if(TextoNuevo.getText().length()==0){
            JOptionPane.showMessageDialog(this,"Error: debe ingresar un tipo de Empresa","Error",0);
        }else{
            try{
                Statement stmt = GestionRutas.getConexion().createStatement();
                stmt.execute("insert into tipo_emp(tipo_emp) values('" + TextoNuevo.getText() + "')");
                stmt.close();
            }catch(SQLException e){
                e.printStackTrace();
            }
            llenarLista();
            TextoNuevo.setText("");
        }
    }

    //** Llena la lista con los valores de la base de datos */
    private void llenarLista(){
      DefaultListModel ModeloLista = new DefaultListModel();
      try{
        Vector Datos = (Vector)TipoEmpresa.getAllNames();
        for(int i=0;i<Datos.size();i++){
          ModeloLista.addElement(Datos.get(i));
        }
        Lista.setModel(ModeloLista);
      }catch(Exception e){
        JOptionPane.showMessageDialog(this,e.getMessage());
      }
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton BotonCrear;
    private javax.swing.JButton BotonEliminar;
    private javax.swing.JButton BotonModificar;
    private javax.swing.JLabel LabelEjemplo;
    private javax.swing.JLabel LabelNuevo;
    private javax.swing.JLabel LabelSeleccion;
    private javax.swing.JLabel LabelTiposExistentes;
    private javax.swing.JList Lista;
    private javax.swing.JScrollPane ScrollPane;
    private javax.swing.JTextField TextoNuevo;
    private javax.swing.JTextField TextoSeleccion;
    private TipoEmpresa TipoEmp;

}
