/*
converter = new ConvertidorExcel(datos,ncols,nfilas);
converter.generarArchivo();
*/
package cl.tefix.ventas.GestionRutas.excel;

import java.io.*;
import java.awt.*;
import javax.swing.*;

public class ConvertidorExcel {

    public ConvertidorExcel() {
        iniciarComponentes();
    }

    public ConvertidorExcel(String [][] datos,String [] Titulos,int nfilas,int ncols){
        this.datos = datos;this.ncols = ncols;this.nfilas = nfilas;this.Titulos = Titulos;
        iniciarComponentes();
    }

    private void iniciarComponentes(){
		filechooser = new JFileChooser();
        DirectorioTemporal = System.getProperties().getProperty("java.io.tmpdir");
		SeparadorDeArchivo = System.getProperties().getProperty("file.separator");
    }

    public void generarArchivo(){
		int opcion;
		File archivo = new File("datos.xls");
		filechooser.setMultiSelectionEnabled(false);
		filechooser.setSelectedFile(archivo);
		opcion = filechooser.showSaveDialog(null);
		if(opcion == JFileChooser.APPROVE_OPTION){
			try{
				fs = new FileOutputStream(filechooser.getSelectedFile());
				bw = new BufferedWriter(new OutputStreamWriter(fs));
				for(int i=0;i<ncols;i++){
					bw.write(Titulos[i].toString().toUpperCase());
					bw.write("\t");
				}
				bw.write("\n");

				for(int i=0;i<nfilas;i++){
					for(int j=0;j<ncols;j++){
						bw.write(datos[i][j].toString());
						bw.write("\t");
					}
					bw.write("\n");
				}
				bw.close();
				fs.close();
			}catch(IOException e){
				e.printStackTrace();
			}
			JOptionPane.showMessageDialog(null,"El Archivo se ha generado correctamente","Informacin",JOptionPane.INFORMATION_MESSAGE);
		}
    }

//Declaraciones
    String DirectorioTemporal,SeparadorDeArchivo;
    String [][] datos;
	String [] Titulos;
	int ncols,nfilas;
    BufferedWriter bw;
    FileOutputStream fs;
	JFileChooser filechooser;
}
