package cl.tefix.ventas.GestionRutas.visitas.empresas;

import cl.tefix.ventas.GestionRutas.*;
import cl.tefix.ventas.GestionRutas.visitas.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.sql.*;

public class FrameBuscarEmpresas extends javax.swing.JInternalFrame {

    /** Creates new form FrameEmpresas */
    public FrameBuscarEmpresas() {
        initComponents();
        iniciarCombos();
        iniciarAcciones();
    }

    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;
        jLabel1 = new javax.swing.JLabel();
        TextoRut = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        TextoNombre = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        ComboTipo = new javax.swing.JComboBox();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        BotonBuscar = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        TablaEmpresas = new javax.swing.JTable();
        ToolBarEmpresas = new javax.swing.JToolBar();
        BotonVolver = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setClosable(true);
        setDefaultCloseOperation(javax.swing.WindowConstants.HIDE_ON_CLOSE);
        setIconifiable(true);
        setMaximizable(true);
        setResizable(true);
        setTitle("Empresas");
        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentHidden(java.awt.event.ComponentEvent evt) {
                formComponentHidden(evt);
            }
        });

        jLabel1.setText("Rut");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        getContentPane().add(jLabel1, gridBagConstraints);

        TextoRut.setMinimumSize(new java.awt.Dimension(114, 22));
        TextoRut.setPreferredSize(new java.awt.Dimension(114, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        getContentPane().add(TextoRut, gridBagConstraints);

        jLabel2.setText("y/o");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 5, 0, 0);
        getContentPane().add(jLabel2, gridBagConstraints);

        TextoNombre.setMinimumSize(new java.awt.Dimension(114, 22));
        TextoNombre.setPreferredSize(new java.awt.Dimension(114, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        getContentPane().add(TextoNombre, gridBagConstraints);

        jLabel3.setText("Nombre");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        getContentPane().add(jLabel3, gridBagConstraints);

        ComboTipo.setMinimumSize(new java.awt.Dimension(130, 24));
        ComboTipo.setPreferredSize(new java.awt.Dimension(114, 24));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        getContentPane().add(ComboTipo, gridBagConstraints);

        jLabel4.setText("y/o");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 5, 0, 0);
        getContentPane().add(jLabel4, gridBagConstraints);

        jLabel5.setText("Tipo");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        getContentPane().add(jLabel5, gridBagConstraints);

        BotonBuscar.setText("Buscar");
        BotonBuscar.setMaximumSize(new java.awt.Dimension(90, 25));
        BotonBuscar.setMinimumSize(new java.awt.Dimension(90, 25));
        BotonBuscar.setPreferredSize(new java.awt.Dimension(90, 25));
        BotonBuscar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BotonBuscarActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 0);
        getContentPane().add(BotonBuscar, gridBagConstraints);

        TablaEmpresas.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Rut", "Nombre", "Tipo", "Prioridad"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        TablaEmpresas.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                TablaEmpresasComponentResized(evt);
            }
        });

        jScrollPane1.setViewportView(TablaEmpresas);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 0, 5);
        getContentPane().add(jScrollPane1, gridBagConstraints);

        ToolBarEmpresas.setFloatable(false);
        BotonVolver.setIcon(new javax.swing.ImageIcon(getClass().getResource("/recursos/iconos/Back16.gif")));
        BotonVolver.setToolTipText("Seleccionar Empresa y volver a la ventana de Visitas");
        BotonVolver.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BotonVolverActionPerformed(evt);
            }
        });

        ToolBarEmpresas.add(BotonVolver);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(ToolBarEmpresas, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-550)/2, (screenSize.height-320)/2, 550, 320);
    }//GEN-END:initComponents

    private void iniciarAcciones(){
        getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke("ENTER"), "Buscar");
        getActionMap().put("Buscar",
            new AbstractAction(){
                public void actionPerformed(ActionEvent e){
                    BotonBuscarActionPerformed(null);
                }
            }
        );
    }

    private void formComponentHidden(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentHidden
        TablaEmpresas.setModel(new DefaultTableModel(new String [][] {},new String [] {"Rut", "Nombre", "Tipo", "Prioridad"}));
        TextoNombre.setText("");
        TextoRut.setText("");
        ComboTipo.setSelectedIndex(0);
    }//GEN-LAST:event_formComponentHidden

    private void BotonVolverActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BotonVolverActionPerformed
        if(TablaEmpresas.getSelectedRow() == -1){
            JOptionPane.showMessageDialog(this,"Error: debe seleccionar una Empresa","Error",0);
        } else{
            String Rut,Nombre,Tipo,Prioridad;
            Rut = TablaEmpresas.getValueAt(TablaEmpresas.getSelectedRow(),0).toString();
            Nombre = TablaEmpresas.getValueAt(TablaEmpresas.getSelectedRow(),1).toString();
            Tipo = TablaEmpresas.getValueAt(TablaEmpresas.getSelectedRow(),2).toString();
            Prioridad = TablaEmpresas.getValueAt(TablaEmpresas.getSelectedRow(),3).toString();
            FrameVisitas.getFrameVisitas().setEmpresa(Rut,Nombre,Tipo,Prioridad);
            setVisible(false);
        }
    }//GEN-LAST:event_BotonVolverActionPerformed

    private void TablaEmpresasComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_TablaEmpresasComponentResized
        fijarAnchos();
    }//GEN-LAST:event_TablaEmpresasComponentResized

    private void BotonBuscarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BotonBuscarActionPerformed
        String tipo;
        if(ComboTipo.getSelectedItem().toString().equals("Todos")){
            tipo = "%%";
        }
        else{
            tipo = ComboTipo.getSelectedItem().toString();
        }

        NumColumnas = 4;
        Datos = null;
        conn = GestionRutas.getConexion();
        try{
            stmt = conn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,ResultSet.CONCUR_UPDATABLE);
            rs = stmt.executeQuery("SELECT rut_emp,nom_emp,tipo_emp.tipo_emp,prioridad FROM empresa WHERE rut_emp like '%" + TextoRut.getText() + "%' AND lower(nom_emp) LIKE '%" + TextoNombre.getText().toLowerCase() + "%'  AND tipo_emp.tipo_emp LIKE '" + tipo + "' AND empresa.tipo_emp = tipo_emp.cod_tipo") ;
            rs.last();
            NumFilas = rs.getRow();
            rs.beforeFirst();
            Datos = new String[NumFilas][NumColumnas];
            int i=0;
            while(rs.next()){
                for(int j=0;j<NumColumnas;j++){
                    Datos[i][j] = rs.getString(j+1);
                }
                i++;
            }
            stmt.close();
            rs.close();
        }catch(SQLException e){
            e.printStackTrace();
        }

        TableModel Modelo = new DefaultTableModel(Datos, new String [] {"Rut", "Nombre", "Tipo", "Prioridad"}){
            public boolean isCellEditable(int fila,int columna){
                return false;
            }
        };
        TablaEmpresas.setModel(Modelo);
        fijarAnchos();
    }//GEN-LAST:event_BotonBuscarActionPerformed

    private void fijarAnchos(){
        TablaEmpresas.getColumnModel().getColumn(1).setPreferredWidth(TablaEmpresas.getSize().width/2);
    }

    private void iniciarCombos(){
        int NumFilas=0;
        try{
            stmtTipos = GestionRutas.getConexion().createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,ResultSet.CONCUR_UPDATABLE);
            rsTipos = stmtTipos.executeQuery("SELECT * FROM tipo_emp");
            rsTipos.last();
            NumFilas = rsTipos.getRow();
            rsTipos.beforeFirst();
            Tipos = new String[NumFilas][2];
            int i=0;
            while(rsTipos.next()){
                for(int j=0;j<2;j++){
                    Tipos[i][j] = rsTipos.getString(j+1);
                }
                i++;
            }
            stmtTipos.close();
            rsTipos.close();
        }catch(SQLException e){
            e.printStackTrace();
        }
        ComboTipo.addItem("Todos");
        for(int i=0;i<NumFilas;i++){
            ComboTipo.addItem(Tipos[i][1]);
        }
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton BotonBuscar;
    private javax.swing.JButton BotonVolver;
    private javax.swing.JComboBox ComboTipo;
    private javax.swing.JTable TablaEmpresas;
    private javax.swing.JTextField TextoNombre;
    private javax.swing.JTextField TextoRut;
    private javax.swing.JToolBar ToolBarEmpresas;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JScrollPane jScrollPane1;
    private Connection conn;
    private Statement stmt,stmtTipos;
    private ResultSet rs,rsTipos;
    private ResultSetMetaData rsmd;
    private String [][] Datos,Tipos;
    private int NumFilas,NumColumnas;
}
